package cadastro;

import UtilDB.Aluno;
import UtilDB.Frequencia;
import UtilDB.Matricula;
import UtilDB.Turma;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;

public class TelaFrequencia extends javax.swing.JFrame {

    private Connection conexao;


    // Metodo construdor da Tela Frequencia
    public TelaFrequencia(java.awt.Frame parent, boolean modal) {
        initComponents();
        this.setLocationRelativeTo(null);
        conexao = new Conexao().obterConexao();
        this.listarTurmas();
        listarAlunos((Turma) jCBTurma.getSelectedItem());
        this.inicializaTabela();
        jTFFaltas.setText("0");

    }

    public void listarTurmas() {
        // lista valores da tabela Turma e ordena por tnum
        String sql = "SELECT * FROM Turma group by tnum";
        jCBTurma.removeAllItems();

        try {
            PreparedStatement st = conexao.prepareStatement(sql);
            ResultSet rs = st.executeQuery();
            int i = 0;
            while (rs.next() == true) {
                Turma turma = new Turma();
                turma.setTid(rs.getInt("tid"));
                turma.setTnum(rs.getInt("tNum"));
                jCBTurma.addItem(turma);


            }
            st.close();
            rs.close();
            System.out.println("Turmas listadas com sucesso.");


        } catch (SQLException ex) {
            System.err.println("Erro ao listar Turmas: " + ex.toString());
        }
    }

    public void listarAlunos(Turma turma) {
    // Faz select na Aluno e Turma;
        String sql = "SELECT a.aid,a.aNome,m.mid FROM Aluno a, Matricula m where a.aid=m.maluno and m.mturma = ?";
        jCBAluno.removeAllItems();
        try {
            PreparedStatement st = conexao.prepareStatement(sql);
            st.setInt(1, turma.getTid());
            ResultSet rs = st.executeQuery();
            int i = 0;
            while (rs.next()) {
                Aluno aluno = new Aluno();
                aluno.setNome(rs.getString("aNome"));
                aluno.setId(rs.getInt("aid"));
                aluno.setIdMatricula(rs.getInt("mID"));

                jCBAluno.addItem(aluno);


            }
            st.close();
            rs.close();
            System.out.println("Alunos listadas com sucesso.");


        } catch (SQLException ex) {
            System.err.println("Erro ao listar : Alunos" + ex.toString());
        }
    }

    private void inserir(Frequencia frequencia) {
        conexao = new Conexao().obterConexao();
        //insert na Tabela frequencia
        String sql = "INSERT INTO Frequencia (feData,feMatricula, feFalta) VALUES (?,?,?)";
        try {



            PreparedStatement st = conexao.prepareStatement(sql);
            //
            st.setString(1, frequencia.getFedata());
            st.setInt(2, frequencia.getMatricula().getAluno().getIdMatricula());
            st.setInt(3, frequencia.getFefalta());
            st.execute();
            st.close();

            System.out.println("Frequencia inserida com sucesso.");
        } catch (SQLException ex) {
            System.err.println("Erro ao inserir frequencia: " + ex.toString());
        }
    }

    public List<Frequencia> listarFrequencia() {
        List lst = new ArrayList();
        // Select na Tabela frequencia , matricula, turma, aluno
        String sql = "SELECT * FROM Frequencia f, Matricula m,Turma t, Aluno a"
                + " WHERE f.feMatricula = m.mID"
                + " AND m.mAluno = a.aID"
                + " and  m.mturma = t.tID"
                + " ORDER BY t.tNum, f.fedata";
        try {
            Connection cone = new Conexao().obterConexao();
            
            PreparedStatement st = cone.prepareStatement(sql);
            ResultSet rs = st.executeQuery();
            while (rs.next()) {
                Frequencia frequencia = new Frequencia();
                frequencia.getMatricula().getTurma().setTnum(rs.getInt("tNum"));
                frequencia.getMatricula().getAluno().setNome(rs.getString("aNome"));
                frequencia.setFefalta(rs.getInt("fefalta"));
                frequencia.setFedata(rs.getString("fedata"));
                lst.add(frequencia);
            }

            st.close();
            rs.close();
            System.out.println("Disciplinas listadas com sucesso.");


        } catch (SQLException ex) {
            System.err.println("Erro ao listar disciplinas:" + ex.toString());
        }
        return lst;
    }

    private void inicializaTabela() {
        DefaultTableModel modelo = (DefaultTableModel) jTFrequencia.getModel();
        //Limpa a lista
        while (modelo.getRowCount() > 0) {
            modelo.removeRow(0);
        }
        List lst = listarFrequencia();
        for (int x = 0; x < lst.size(); x++) {
            Frequencia frequencia = (Frequencia) lst.get(x);
            String vetor[] = new String[4];
            vetor[0] = frequencia.getMatricula().getTurma().getTnum() + "";
            vetor[1] = frequencia.getMatricula().getAluno().getNome();
            vetor[2] = frequencia.getFefalta() + "";
            vetor[3] = frequencia.getFedata();
            modelo.addRow(vetor);
        }

    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jCBTurma = new javax.swing.JComboBox();
        jLabel4 = new javax.swing.JLabel();
        jTFFaltas = new javax.swing.JTextField();
        jBInserir = new javax.swing.JButton();
        jBCancelar = new javax.swing.JButton();
        jCBAluno = new javax.swing.JComboBox();
        jLabel3 = new javax.swing.JLabel();
        jTFData = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTFrequencia = new javax.swing.JTable();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jLabel1.setText("Data:");

        jLabel2.setText("Turma:");

        jCBTurma.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        jCBTurma.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jCBTurmaMousePressed(evt);
            }
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jCBTurmaMouseClicked(evt);
            }
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                jCBTurmaMouseEntered(evt);
            }
        });
        jCBTurma.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                jCBTurmaMouseMoved(evt);
            }
        });
        jCBTurma.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCBTurmaItemStateChanged(evt);
            }
        });
        jCBTurma.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCBTurmaActionPerformed(evt);
            }
        });
        jCBTurma.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                jCBTurmaFocusLost(evt);
            }
        });
        jCBTurma.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                jCBTurmaPropertyChange(evt);
            }
        });
        jCBTurma.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jCBTurmaKeyPressed(evt);
            }
        });

        jLabel4.setText("N. de Faltas:");

        jBInserir.setText("Inserir");
        jBInserir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBInserirActionPerformed(evt);
            }
        });

        jBCancelar.setText("Cancelar");
        jBCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBCancelarActionPerformed(evt);
            }
        });

        jCBAluno.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        jLabel3.setText("Aluno:");

        jTFrequencia.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "TURMA", "ALUNO", "FALTAS", "DATA"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.Integer.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(jTFrequencia);
        jTFrequencia.getColumnModel().getColumn(0).setMaxWidth(200);
        jTFrequencia.getColumnModel().getColumn(2).setMaxWidth(60);
        jTFrequencia.getColumnModel().getColumn(3).setMaxWidth(120);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 470, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addComponent(jLabel4)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTFFaltas, javax.swing.GroupLayout.PREFERRED_SIZE, 34, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(86, 86, 86))
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel2)
                                    .addComponent(jLabel3)
                                    .addComponent(jLabel1))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(jTFData)
                                    .addComponent(jCBTurma, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jCBAluno, javax.swing.GroupLayout.PREFERRED_SIZE, 143, javax.swing.GroupLayout.PREFERRED_SIZE))))
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jBCancelar)
                            .addComponent(jBInserir))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jTFData, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jBInserir)))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel2)
                            .addComponent(jCBTurma, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(11, 11, 11)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jCBAluno, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel3))
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel4)
                            .addComponent(jTFFaltas, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(jBCancelar))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 105, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jBInserirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBInserirActionPerformed
       // Verifica se o campo Data ou N. de faltas da tela estao vazios
        if ((jTFData.getText().equals(""))|| (jTFFaltas.getText().equals(""))) {
            // Joga mensagem na tela informando que estão faltando dados.
            JOptionPane.showMessageDialog(null, "Faltando Dados");
        } else {
        Frequencia frequencia = new Frequencia();
        frequencia.setFedata(jTFData.getText());
        
        frequencia.setFefalta(Integer.parseInt(jTFFaltas.getText()));
        //Typecast Aluno
        frequencia.getMatricula().setAluno((Aluno) jCBAluno.getSelectedItem());
        inserir(frequencia);
        this.inicializaTabela();
        }

    }//GEN-LAST:event_jBInserirActionPerformed

    private void jBCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBCancelarActionPerformed
        this.dispose();
    }//GEN-LAST:event_jBCancelarActionPerformed

    private void jCBTurmaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCBTurmaActionPerformed
    }//GEN-LAST:event_jCBTurmaActionPerformed

    private void jCBTurmaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jCBTurmaMouseClicked
        listarAlunos((Turma) jCBTurma.getSelectedItem());
    }//GEN-LAST:event_jCBTurmaMouseClicked

    private void jCBTurmaItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCBTurmaItemStateChanged
    }//GEN-LAST:event_jCBTurmaItemStateChanged

    private void jCBTurmaMouseMoved(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jCBTurmaMouseMoved
         listarAlunos((Turma)jCBTurma.getSelectedItem());
    }//GEN-LAST:event_jCBTurmaMouseMoved

    private void jCBTurmaKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jCBTurmaKeyPressed
    }//GEN-LAST:event_jCBTurmaKeyPressed

    private void jCBTurmaMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jCBTurmaMousePressed
    }//GEN-LAST:event_jCBTurmaMousePressed

    private void jCBTurmaPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_jCBTurmaPropertyChange
    }//GEN-LAST:event_jCBTurmaPropertyChange

    private void jCBTurmaFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jCBTurmaFocusLost
        // TODO add your handling code here:
    }//GEN-LAST:event_jCBTurmaFocusLost

    private void jCBTurmaMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jCBTurmaMouseEntered
    }//GEN-LAST:event_jCBTurmaMouseEntered
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBCancelar;
    private javax.swing.JButton jBInserir;
    private javax.swing.JComboBox jCBAluno;
    private javax.swing.JComboBox jCBTurma;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField jTFData;
    private javax.swing.JTextField jTFFaltas;
    private javax.swing.JTable jTFrequencia;
    // End of variables declaration//GEN-END:variables
}
